Gecode::Set::Rel::CharacteristicSets Class Reference

Representation of the characteristic functions of two sets. More...

`#include <lq.hpp>`

## Classes

class | CSIter
| Value iterator for characteristic function. More...

## Public Member Functions

template<class View0, class View1>
| CharacteristicSets (Region &re, View0 x, View1 y)
| Constructor.
bool | xmin (unsigned int i) const
| Return minimum of element i for variable x.
bool | xmax (unsigned int i) const
| Return maximum of element i for variable x.
bool | ymin (unsigned int i) const
| Return minimum of element i for variable y.
bool | ymax (unsigned int i) const
| Return maximum of element i for variable y.
void | xmin (unsigned int i, bool j)
| Set minimum of element i for variable x to j.
void | xmax (unsigned int i, bool j)
| Set maximum of element i for variable x to j.
void | ymin (unsigned int i, bool j)
| Set minimum of element i for variable y to j.
void | ymax (unsigned int i, bool j)
| Set maximum of element i for variable y to j.
ModEvent | xlq (unsigned int i, bool j)
| Update upper bound of to j.
ModEvent | xgq (unsigned int i, bool j)
| Update lower bound of to j.
ModEvent | ylq (unsigned int i, bool j)
| Update upper bound of to j.
ModEvent | ygq (unsigned int i, bool j)
| Update lower bound of to j.
unsigned int | size (void) const
| Return size of combined upper bounds.
template<class View0, class View1>
ExecStatus | prune (Space &home, View0 x, View1 y)
| Prune x and y using computed bounds.

## Protected Member Functions

bool | get (unsigned int i) const
| Get bit i.
void | set (unsigned int i, bool j)
| Set bit i to value j.

## Protected Attributes

unsigned int | xsize
| Size of the combined upper bounds.
Support::BitSetBase | b
| Storage for the characteristic functions.
int * | ub
| Elements in the combined upper bounds.
bool | xlm
| Whether lower bound of x was updated.
bool | xum
| Whether upper bound of x was updated.
bool | ylm
| Whether lower bound of y was updated.
bool | yum
| Whether upper bound of y was updated.

## Detailed Description

Representation of the characteristic functions of two sets.

Definition at line 39 of file lq.hpp.

## Constructor & Destructor Documentation

## CharacteristicSets()

template<class View0, class View1>

Gecode::Set::Rel::CharacteristicSets::CharacteristicSets | ( | Region & | re,
|  | View0 | x,
|  | View1 | y )

inline

Constructor.

Definition at line 273 of file lq.hpp.

## Member Function Documentation

## get()

bool Gecode::Set::Rel::CharacteristicSets::get | ( | unsigned int | i | ) | const

inline protected

Get bit i.

Definition at line 126 of file lq.hpp.

## set()

void Gecode::Set::Rel::CharacteristicSets::set | ( | unsigned int | i,
|  | bool | j )

inline protected

Set bit i to value j.

Definition at line 130 of file lq.hpp.

## xmin() [1/2]

bool Gecode::Set::Rel::CharacteristicSets::xmin | ( | unsigned int | i | ) | const

inline

Return minimum of element i for variable x.

Definition at line 167 of file lq.hpp.

## xmax() [1/2]

bool Gecode::Set::Rel::CharacteristicSets::xmax | ( | unsigned int | i | ) | const

inline

Return maximum of element i for variable x.

Definition at line 171 of file lq.hpp.

## ymin() [1/2]

bool Gecode::Set::Rel::CharacteristicSets::ymin | ( | unsigned int | i | ) | const

inline

Return minimum of element i for variable y.

Definition at line 175 of file lq.hpp.

## ymax() [1/2]

bool Gecode::Set::Rel::CharacteristicSets::ymax | ( | unsigned int | i | ) | const

inline

Return maximum of element i for variable y.

Definition at line 179 of file lq.hpp.

## xmin() [2/2]

void Gecode::Set::Rel::CharacteristicSets::xmin | ( | unsigned int | i,
|  | bool | j )

inline

Set minimum of element i for variable x to j.

Definition at line 184 of file lq.hpp.

## xmax() [2/2]

void Gecode::Set::Rel::CharacteristicSets::xmax | ( | unsigned int | i,
|  | bool | j )

inline

Set maximum of element i for variable x to j.

Definition at line 188 of file lq.hpp.

## ymin() [2/2]

void Gecode::Set::Rel::CharacteristicSets::ymin | ( | unsigned int | i,
|  | bool | j )

inline

Set minimum of element i for variable y to j.

Definition at line 192 of file lq.hpp.

## ymax() [2/2]

void Gecode::Set::Rel::CharacteristicSets::ymax | ( | unsigned int | i,
|  | bool | j )

inline

Set maximum of element i for variable y to j.

Definition at line 196 of file lq.hpp.

## xlq()

ModEvent Gecode::Set::Rel::CharacteristicSets::xlq | ( | unsigned int | i,
|  | bool | j )

inline

Update upper bound of to j.

Definition at line 201 of file lq.hpp.

## xgq()

ModEvent Gecode::Set::Rel::CharacteristicSets::xgq | ( | unsigned int | i,
|  | bool | j )

inline

Update lower bound of to j.

Definition at line 212 of file lq.hpp.

## ylq()

ModEvent Gecode::Set::Rel::CharacteristicSets::ylq | ( | unsigned int | i,
|  | bool | j )

inline

Update upper bound of to j.

Definition at line 223 of file lq.hpp.

## ygq()

ModEvent Gecode::Set::Rel::CharacteristicSets::ygq | ( | unsigned int | i,
|  | bool | j )

inline

Update lower bound of to j.

Definition at line 234 of file lq.hpp.

## size()

unsigned int Gecode::Set::Rel::CharacteristicSets::size | ( | void |  | ) | const

inline

Return size of combined upper bounds.

Definition at line 137 of file lq.hpp.

## prune()

template<class View0, class View1>

ExecStatus Gecode::Set::Rel::CharacteristicSets::prune | ( | Space & | home,
|  | View0 | x,
|  | View1 | y )

inline

Prune x and y using computed bounds.

Definition at line 247 of file lq.hpp.

## Member Data Documentation

## xsize

unsigned int Gecode::Set::Rel::CharacteristicSets::xsize

protected

Size of the combined upper bounds.

Definition at line 42 of file lq.hpp.

## b

Support::BitSetBase Gecode::Set::Rel::CharacteristicSets::b

protected

Storage for the characteristic functions.

Definition at line 44 of file lq.hpp.

## ub

int* Gecode::Set::Rel::CharacteristicSets::ub

protected

Elements in the combined upper bounds.

Definition at line 46 of file lq.hpp.

## xlm

bool Gecode::Set::Rel::CharacteristicSets::xlm

protected

Whether lower bound of x was updated.

Definition at line 48 of file lq.hpp.

## xum

bool Gecode::Set::Rel::CharacteristicSets::xum

protected

Whether upper bound of x was updated.

Definition at line 50 of file lq.hpp.

## ylm

bool Gecode::Set::Rel::CharacteristicSets::ylm

protected

Whether lower bound of y was updated.

Definition at line 52 of file lq.hpp.

## yum

bool Gecode::Set::Rel::CharacteristicSets::yum

protected

Whether upper bound of y was updated.

Definition at line 54 of file lq.hpp.

The documentation for this class was generated from the following file:

- gecode/set/rel/lq.hpp